;============================================================================
;	MZ-700pPCG MAPPYMZ-1500œpb`
;============================================================================
	ORG	0CF00h

RDINF	EQU	0027h
RDDAT	EQU	002Ah
LDERR	EQU	00FEh
NL	EQU	0009h
LDMSG	EQU	013Eh
NAME	EQU	10F1h

	DI
;
;	IPL ROMRAMɃRs[
;
	LD	HL, 0000h
@@:	OUT	(0E2h), A	; MONITOR ROM
	LD	A, (HL)
	OUT	(0E0h), A	; DRAM
	LD	(HL), A
	INC	HL
	BIT	4, H
	JR	Z, @b
	LD	A, 0D3h		; ?PONT VRAM擪AhXpb`
	LD	(0FBEh), A
	OUT	(0E2h), A	; MONITOR ROM

;
;	MAPPY PCG`[h
;
;;;CALL 09B3h
	CALL	RDINF
	JP	C, LDERR
	CALL	NL
	LD	DE, LDMSG	; 'LOADING'
	RST	18h
	LD	DE, NAME	; FILENAME
	RST	18h
	CALL	RDDAT
	JP	C, LDERR

;
;	PCG` (00h-7Fh: CGROM)
;
	LD	HL, 0D000h
	LD	C, 0E5h
@@:	LD	B, 00h
	OUT	(C), B		; CGROM
	INC	B
	LD	A, (HL)
	CPL
	OUT	(C), B		; BLUE
	INC	B
	LD	(HL), 0
	OUT	(C), B		; RED
	INC	B
	LD	(HL), A
	OUT	(C), B		; GREEN
	LD	(HL), A
	INC	HL
	BIT	2, H		; D400h ?
	JR	Z, @b

;
;	PCG` (80h-FFh: PCG)
;
	LD	DE, 5C00h
@@:	LD	A, (DE)		; PCG
	INC	DE
	CPL
	LD	B, 01h
	OUT	(C), B		; BLUE
	INC	B
	LD	(HL), 0
	OUT	(C), B		; RED
	INC	B
	LD	(HL), A
	OUT	(C), B		; GREEN
	LD	(HL), A
	INC	HL
	BIT	3, H		; D800h?
	JR	Z, @b

	OUT	(0E6h), A

	CALL	NL
	LD	DE, 5B6Dh
	RST	18h
	CALL	NL

;
;	MAPPY{̂[h
;
	CALL	RDINF
	JP	C, LDERR
	CALL	NL
	LD	DE, LDMSG	; 'LOADING'
	RST	18h
	LD	DE, NAME	; FILENAME
	RST	18h
	CALL	RDDAT
	JP	C, LDERR

;
;	pbg`
;
	XOR	A
@@:	OUT	(0F1h), A
	ADD	A, 11h
	JP	P, @b
	LD	A, 60h		; pbgR[h6 = 
	OUT	(0F1h), A
	LD	A, 06h		; pbgR[h0 = 
	OUT	(0F1h), A

;
;	eLXgVRAM
;
	LD	HL, 0D000h
	LD	DE, 0D001h
	LD	BC, 999
	LD	(HL), 43h
	LDIR

;
;	PCGVRAM2
;
	LD	HL, 0DC00h
	LD	DE, 0DC01h
	LD	BC, 999
	LD	(HL), 08h
	LDIR

;
;	PCG\/vCIeBZbg
;
	LD	A, 3
	OUT	(0F0h), A

;
;	pb`𓖂Ă
;
	LD	HL, PATCHDATA
@3:	LD	E, (HL)
	INC	HL
	LD	D, (HL)		; DE = pb`ăAhX
	LD	A, D
	OR	E
	JR	Z, @1f
	INC	HL
	LD	A, (DE)
	ADD	A, 04h
	LD	(DE), A
	JR	@3b
@1:	LD	A, 21h
	LD	(2FF5h), A
	LD	(2FFBh), A
	LD	A, 0F0h
	LD	(5A8Ch), A
	LD	(5AA3h), A

;
;	MAPPY ^Cgʂ[h
;
	CALL	RDINF
	JP	C, LDERR
	CALL	RDDAT
	JP	C, LDERR

	OUT	(0E0h), A	; pb`IPL ROM(DRAM)ɐ؂ւ
	JP	2C00h		; MAPPYs

;============================================================================
;	pb`f[^
;============================================================================
PATCHDATA:	; AhX(W), (B), f[^(B)...

	DW	3021h

	DW	3178h

	DW	32A2h

	DW	32ABh

	DW	32BBh

	DW	32DDh

	DW	32F4h

	DW	3323h

	DW	3333h

	DW	0CDBAh

	;
	; pb`f[^I
	;
	DW	0

	END
